﻿using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Diagnostics;
using System.Threading.Tasks;

namespace WriteToArray
{
    class Program
    {
        private static readonly int NumberOfTasks = 10000;
        private static readonly int NumberOfLoops = 1000;
        //private static readonly List<int> Numbers = new List<int>();
        private static readonly List<int> Numbers = new List<int>(NumberOfTasks * NumberOfLoops);
        //private static readonly ConcurrentBag<int> Numbers = new ConcurrentBag<int>(); 
        // Very slow compared to List + lock!!

        private static void Write(int howMany)
        {
            for (int i = 0; i < howMany; i++)
            {
                //lock (Numbers)
                //{
                    Numbers.Add(i);
                //}
            }
        }

        static void Main()
        {
            List<Task> tasks = new List<Task>(NumberOfTasks);
            Stopwatch stopwatch = Stopwatch.StartNew();
            for (int i = 0; i < NumberOfTasks; i++)
            {
                Task task = Task.Run(() => Write(NumberOfLoops));
                tasks.Add(task);
            }
            Task.WaitAll(tasks.ToArray());
            stopwatch.Stop();
            Console.WriteLine("Count: " + Numbers.Count + " Time: " + stopwatch.ElapsedMilliseconds);
        }
    }
}
